import numpy as np
import Training_data

rng = np.random.default_rng(123)
TEACHDATA = 10000
TESTDATA = 1000
# ETA = 0.5
T_NUMBER = 0


def sigmoid(val):
    return 1 / (1 + np.exp(-val))


def linear_act(val):
    return val


def threshold(val):
    return 1 if val > 0 else 0


class Perceptron:
    def __init__(self, input_count, activation=threshold):
        self.input_count = input_count
        self.activation = activation
        self.weights = rng.random(input_count + 1)

    def train(self, ETA):
        teach_data = Training_data.make_testset(TEACHDATA)
        for i in range(TEACHDATA):
            old_weights = np.copy(self.weights)
            for j in rng.permutation(len(teach_data)):
                T = 1 if j == T_NUMBER else 0
                ix = np.insert(teach_data[j][i].ravel(), 0, 1)
                RI = self.activation(ix.dot(self.weights))
                if RI != T:
                    delta = ETA * \
                        (T - self.activation(ix.dot(self.weights))) * ix
                    self.weights = self.weights + delta
                # print(self.weights[0], self.weights[1], self.weights[2], self.weights[3], self.weights[4], self.weights[5], self.weights[6])
            if np.linalg.norm(old_weights - self.weights) == 0.00:
                return self.weights
        return self.weights

    def test(self):
        test_data = Training_data.make_testset(TESTDATA)
        res = [0 for _ in range(len(test_data))]
        for number in range(len(test_data)):
            for sample in test_data[number]:
                ix = np.insert(sample.ravel(), 0, 1)
                res[number] = res[number] + \
                    (self.activation(ix.dot(self.weights)))
        return res
